SystemOrganization addCategory: #SwazooSpike!

SwazooResource subclass: #S2JWebApp
	instanceVariableNames: 'requestCount'
	classVariableNames: 'responseContent'
	poolDictionaries: ''
	category: 'SwazooSpike'!

!S2JWebApp class methodsFor: 'as yet unclassified' stamp: 'SW 12/1/2010 13:28'!
prepareSite
	| site |
	site := SwazooSite newNamed: self siteName. 
	site host: '*' ip: '*' port: 6666.
	site addResource: (self uriPattern: '/').
	^site! !

!S2JWebApp class methodsFor: 'accessing' stamp: 'SW 12/1/2010 16:28'!
responseContent
	^responseContent
! !

!S2JWebApp class methodsFor: 'accessing' stamp: 'SW 12/1/2010 16:15'!
responseContent: anObject
	responseContent := anObject! !

!S2JWebApp class methodsFor: 'as yet unclassified' stamp: 'SW 12/1/2010 13:27'!
siteName
	^'S2JWebApp'! !

!S2JWebApp class methodsFor: 'as yet unclassified' stamp: 'SW 12/1/2010 13:29'!
startWebApp
	| site |
	site := SwazooServer singleton siteNamed: self siteName.
	site isNil ifTrue: [site := self prepareSite].
	site start.
! !

!S2JWebApp methodsFor: 'as yet unclassified' stamp: 'SW 12/1/2010 15:47'!
answerHTMLTo: aRequest 
	| response resource  |
	resource := aRequest requestLine requestURI identifier.
	response := HTTPResponse ok.
	response
		contentType: 'text/html';
		entity: ((self renderHeaderFor:resource) , 
	 	   	    (self renderContentFor:resource) ,
	  		    (self renderFooterFor:resource)).
	
	^response
		
! !

!S2JWebApp methodsFor: 'as yet unclassified' stamp: 'SW 12/1/2010 16:25'!
answerNothing

	^ HTTPResponse notModified.! !

!S2JWebApp methodsFor: 'as yet unclassified' stamp: 'SW 12/1/2010 16:16'!
answerTo: aRequest 

	| resource  |
	resource := self identifierOf: aRequest.
	
	^ resource = '/xml' 
		ifTrue: [ self answerXMLTo: aRequest ]
		ifFalse: [ self answerHTMLTo: aRequest ].
		
! !

!S2JWebApp methodsFor: 'as yet unclassified' stamp: 'SW 12/1/2010 16:21'!
answerXML

	| response |
	
	response := HTTPResponse ok.
	^ response
		contentType: 'xml';
		entity: self class responseContent;
		yourself.
! !

!S2JWebApp methodsFor: 'as yet unclassified' stamp: 'SW 12/1/2010 16:27'!
answerXMLTo: aRequest 

	^ self class responseContent
		ifNil: [ self answerNothing ]
		ifNotNil: [ self answerXML ]
! !

!S2JWebApp methodsFor: 'as yet unclassified' stamp: 'SW 12/1/2010 16:08'!
identifierOf: aRequest

	^ aRequest requestLine requestURI identifier.! !

!S2JWebApp methodsFor: 'as yet unclassified' stamp: 'SW 12/1/2010 16:24'!
javascriptCodeForSynchronisation
	 ^'<script  type="text/javascript" language="javascript">	
		var request;
function createXMLRequest() {
	var request = null;
	try { request = new XMLHttpRequest(); }
	catch(e) {
		try { request = new ActiveXObject("Msxml2.XMLHTTP"); }
		catch(e) {
			try { request = new ActiveXObject("Microsoft.XMLHTTP"); } 
            catch(failed) {
            	request = null;
            }
     	}
	}
	if (request == null) {
		alert("Cant create request")
	}	
	return request;
}

function initialize() {
	request = createXMLRequest();
	request.open("GET", "http://localhost:6666/xml", true);
	request.onreadystatechange = requestHandler;
	request.send(null);	
}

function requestHandler() {
	alert(request..status);
	if (request.readyState == 4){
		switch (request.status) {
			case 200:
				var xmldoc = request.responseXML;
				var nodes = xmldoc.getElementsByTagName("node");
				var element = document.createElement("div");
				element.innerHTML = nodes[0].childNodes[0].nodeValue ;
				document.getElementById("messages").appendChild(element  ); 
				request.open("GET", "http://localhost:6666/xml", true);
				setTimeout("request.send(null);",1250);
					
				break;
			default:
				alert("write failure - status " + request.status);
		}
	}
	else {
		//alert("aa");
	}
}



</script>'! !

!S2JWebApp methodsFor: 'as yet unclassified' stamp: 'SW 12/1/2010 15:30'!
renderContentFor:resource
	requestCount :=0.
	resource = '/app' 
		ifTrue: [^'Hello World<br><div id="messages"></div>'] 
		ifFalse: [^'Error']! !

!S2JWebApp methodsFor: 'as yet unclassified' stamp: 'SW 12/1/2010 14:22'!
renderFooterFor:resource
	^'</body></html>'! !

!S2JWebApp methodsFor: 'as yet unclassified' stamp: 'SW 12/1/2010 14:36'!
renderHeaderFor:resource
	^'<html>
		<head>
			<title>S2JWebApp</title>
		</head>', self javascriptCodeForSynchronisation , '
	  	<body onload="initialize()">'! !

!S2JWebApp methodsFor: 'as yet unclassified' stamp: 'SW 12/1/2010 15:29'!
renderXmlAnswer
	|result | 
	result :='<?xml version="1.0" encoding="UTF-8"?>
		<node>'.

	requestCount < 5 ifTrue: [
		requestCount := requestCount +1.			
		result := result , 'Hello World'.
		]
		ifFalse: [
			
			result := result , 'Hello Hauke'.
		].
	result := result , '</node>'.
	^result ! !
